/*
 **********************************************************************
 * Copyright (c)  2008 - 2022, Shanghai AisinoChip Co.,Ltd .
 * @file        main.c    
 * @version     V1.0.0
 * @date        2022 
 * @author      Aisinochip Firmware Team  
 * @brief       Standby Test Main File 
 **********************************************************************
 */
#include "APP.h"

UART_HandleTypeDef Uart_Handle;

/*********************************************************************************
* Function    : Uart_Init
* Description : Uart Initialization
**********************************************************************************/
void Uart_Init(uint32_t fu32_Baudrate)
{
    Uart_Handle.Instance        = UART2;
    Uart_Handle.Init.BaudRate   = fu32_Baudrate;
    Uart_Handle.Init.WordLength = UART_WORDLENGTH_8B;
    Uart_Handle.Init.StopBits   = UART_STOPBITS_1;
    Uart_Handle.Init.Parity     = UART_PARITY_NONE;
    Uart_Handle.Init.Mode       = UART_MODE_TX_RX_DEBUG;
    Uart_Handle.Init.HwFlowCtl  = UART_HWCONTROL_NONE;

    HAL_UART_Init(&Uart_Handle);  
    
    // UART_DEBUG_ENABLE control printfS=
    printfS("MCU is running, HCLK=%dHz, PCLK=%dHz\n", System_Get_SystemClock(), System_Get_APBClock());
}

void GPIO_Turn()  /* תIOʱ */
{
    GPIO_InitTypeDef GPIOx_Handle;
    uint32_t i;
    GPIOx_Handle.Pin       = GPIO_PIN_3 ;
    GPIOx_Handle.Mode      = GPIO_MODE_OUTPUT_PP;
    GPIOx_Handle.Pull      = GPIO_PULLUP;
    GPIOx_Handle.Alternate = GPIO_FUNCTION_0;

    HAL_GPIO_Init(GPIOF, &GPIOx_Handle);

    for(i = 0; i < 20 ; i++)
    {   
		HAL_GPIO_WritePin(GPIOF, GPIO_PIN_3 , GPIO_PIN_SET);
		System_Delay_MS(100);
        HAL_GPIO_WritePin(GPIOF, GPIO_PIN_3 , GPIO_PIN_CLEAR);
		System_Delay_MS(100);
    }
}


/*********************************************************************************
* Function    : main
* Description : The application entry point.
* Input       : None
* Output      : None
**********************************************************************************/
int main(void)
{
    System_Init();
    
    Uart_Init(115200);
    
    while(1)
    {
        GPIO_Turn();   //GPIOת൱ʱ
        
        printfS("MCU enter stop mode, MCU will wakeup by PA0 rising edge!\n"); 
        
        LowPower_STOP();
        
        System_Init();
        
        Uart_Init(115200);
        
        printfS("MCU EXTI stop mode!\n"); 
    }
}

