/*
 **********************************************************************
 * Copyright (c)  2008 - 2022, Shanghai AisinoChip Co.,Ltd .
 * @file        main.c    
 * @version     V1.0.0
 * @date        2022 
 * @author      Aisinochip Firmware Team  
 * @brief       UART Test Main File 
 **********************************************************************
 */
#include "APP.h" 

#define UART_BAUD_RATE  115200       

UART_HandleTypeDef UART2_Handle;

//static uint8_t gu8_UART1Test[] = {"This is UART1 Test Data"};
//static uint8_t gu8_UART3Test[] = {"This is UART3 Test Data"};

/************************************************************************
 * function   : Uart_Init
 * Description: Uart Initiation. 
 ************************************************************************/ 
void Uart_Init(void) 
{
    UART2_Handle.Instance        = UART1;    
    UART2_Handle.Init.BaudRate   = UART_BAUD_RATE; 
    UART2_Handle.Init.WordLength = UART_WORDLENGTH_8B;
    UART2_Handle.Init.StopBits   = UART_STOPBITS_1;
    UART2_Handle.Init.Parity     = UART_PARITY_NONE;
    UART2_Handle.Init.Mode       = UART_MODE_TX_RX_DEBUG;
    UART2_Handle.Init.HwFlowCtl  = UART_HWCONTROL_NONE;
    
    HAL_UART_Init(&UART2_Handle);     
    /* ENABLE FIFO */ 
    HAL_UART_Enable_Disable_FIFO(&UART2_Handle,FUNC_ENABLE); 
    
    /* UART_DEBUG_ENABLE control printfS */     
//    printfS("MCU is running, HCLK=%dHz, PCLK=%dHz\n", (int)System_Get_SystemClock(), (int)System_Get_APBClock());       
}


/*********************************************************************************
* Function    : main
* Description : The application entry point.
* Input       : None
* Output      : None
**********************************************************************************/
int main(void)
{
	uint32_t i = 0;
    System_Init();
    Uart_Init();
	
	for(i=0;i<41;i++)
	{
		NVIC_DisableIRQ(i);
	}

//    __set_PRIMASK(1);
//    SCB->ICSR = BIT25;   // clear systick pending bit     
	i=0;
    while(1)
    {
        printfS("hello, %d\r\n", (int)i++);
        System_Delay_MS(1000);
    }
}
void SysTick_Handler(void)
{
    gu32_SystemCount++;
}